/* CallCache.h -*- c++ -*- Hans-Peter Stoerr Sat Feb  6 1999 */

#ifndef _CALLCACHE_H
#define _CALLCACHE_H

#include <map>

template <class T, class ResultType, class FirstArgType, class ArgsType>
class CallCache
{
  typedef pair< pair<FirstArgType, ResultType (T::*)(...)>,
    pair<T*, ArgsType> > MapArg;
  typedef map<MapArg, ResultType> MapType;
public:
  bool  Called(ResultType* res, T* theThis, ResultType (T::*func)(...) ,
               const FirstArgType& arg1, const Argstype& args)
  {
    MapType::const_iterator it=
      cache.find(pair(pair(arg1,func),pair(theThis,args)));
    if (cache.end()==it) return FALSE;
    *res=*it; return TRUE;
  } 
  void  SetResult(const ResultType& res, T* theThis, ResultType (T::*func)(...) ,
                  const FirstArgType& arg1, const Argstype& args)
  {
    cache[pair(pair(arg1,func),pair(theThis,args))]=res;
  }
private:
  static MapType cache;
};

#endif
