/* RubberbandOrder.h -*- c++ -*- Hans-Peter Stoerr Fri Feb 11 2000 */

#ifndef _RUBBERBANDORDER_H
#define _RUBBERBANDORDER_H

#include <vector>
#include <pair.h>
#include <string>
#include <map>

class RubberbandOrder
{
public:
  RubberbandOrder()
  { mCalculated=0; mCurNum=0; mNumNodes=0; mNumEdges=0; mEdge.push_back(vector<int>()); }
  ~RubberbandOrder() {}
  void  InsertEdge(pair<string,string>);

  const vector<string>& Result() {if(!mCalculated) { Calculate(); mCalculated=1; } return Band;}
public:                         // don`t touch my private parts... (or please do? :-)
  void  Calculate();            // control function for calculation
  void  MakeDistances(int n);   // calculate distances of all nodes to Node n.
  double        MoveNode(int n); // new position of node n in mPos.
  void  MakeOrder();            // calculate an order w. mTopNode and mBotNode
 
  vector<string>        Band;   // Resultat
  bool  mCalculated;

  int   mNumNodes,mNumEdges;    // number of nodes and edges (counted unweighted.)
  vector<vector<int> > mEdge;  // remembers the nodes each node has an edge to
  map<pair<int,int>,int> mWeight; // the weight of each edge (i.e. multip. of edge.)
  map<string,int>  mNameToNumber; // maps the names of the elements to a number
  map<int,string>  mNumberToName; // inverse of mNumberToName

  int   mTopNode, mBotNode;     // top and bottom nodes in the variable order
  
  // variables for implementation of algorithms
  int   mCurNum;                // current number of next element.
  vector<vector<int> >  mDist;  // vectors of nodes for each distance
  vector<bool>  mConnected;     // tells nodes which are connected to m.
  vector<double> mPos;          // positions of the nodes
};


#endif
