(define (domain movie-dom) (:requirements :adl :typing)
  (:types chips dip pop cheese crackers - object)
  (:predicates (movie-rewound)
               (counter-at-two-hours)
               (counter-at-zero)
               (have-chips)
               (have-dip)
               (have-pop)
               (have-cheese)
               (have-crackers))
  


  
  (:action rewind-movie
           :parameters ()
           :effect (and (movie-rewound)
                        ;; Let's assume that the movie is 2 hours long
                        (when (not (counter-at-two-hours)) 
                          (not (counter-at-zero)))))
  
  (:action reset-counter
           :parameters ()
           :effect (counter-at-zero))


  ;;; Get the food and snacks for the movie
  (:action get-chips

           :parameters (?x - chips)
           :effect (have-chips))
  
  (:action get-dip
           :parameters (?x - dip)
           :effect (have-dip))

  (:action get-pop
           :parameters (?x - pop)
           :effect (have-pop))
  
  (:action get-cheese
           :parameters (?x - cheese)
           :effect (have-cheese))
  
  (:action get-crackers
           :parameters (?x - crackers)
           :effect (have-crackers)))

(define (problem movie-x-1)
   (:domain movie-dom)
   (:objects c5 c4 c3 c2 c1 - chips
             d5 d4 d3 d2 d1 - dip
             p5 p4 p3 p2 p1 - pop
             z5 z4 z3 z2 z1 - cheese
             k5 k4 k3 k2 k1 - crackers)
   (:init (not (movie-rewound))
          (not (counter-at-two-hours))
          (not (counter-at-zero)))
   (:goal (and (movie-rewound)
               (counter-at-zero)
               (have-chips)
               (have-dip)
               (have-pop)
               (have-cheese)
               (have-crackers))))
