(define (domain mystery-prime-typed)
   (:requirements :typing  :quantified-preconditions :conditional-effects)
   (:types province planet food emotion - object
           pleasure pain - emotion)
   (:predicates
       (eats ?n1 ?n2 - food)
       (craves ?v - emotion ?n - food)
       (fears ?c - pain ?v - pleasure)
       (locale ?n - food ?a - province)
       (harmony ?v - emotion ?s - planet)
       (attacks ?i ?j - province)
       (orbits ?i ?j - planet))

   (:action overcome
       :parameters (?c - pain ?v - pleasure)
       :vars (?n - food ?s1 ?s2 - planet)
       :precondition (and (craves ?c ?n)
                          (craves ?v ?n)
                          (harmony ?v ?s2)
                          (orbits ?s1 ?s2))
       :effect (and (not (craves ?c ?n))
                    (fears ?c ?v)
                    (not (harmony ?v ?s2))
                    (harmony ?v ?s1)))
   (:action feast
       :parameters (?v - pleasure ?n1 ?n2 - food)
       :vars (?l1 ?l2 - province)
       :precondition (and (craves ?v ?n1)
                          (eats ?n1 ?n2)
                          (locale ?n1 ?l2)
                          (attacks ?l1 ?l2))
       :effect (and (not (craves ?v ?n1))
                    (craves ?v ?n2)
                    (not (locale ?n1 ?l2))
                    (locale ?n1 ?l1)))
   (:action succumb
       :parameters (?c - pain ?v - pleasure)
       :vars (?n - food ?s1 ?s2 - planet)
       :precondition (and (fears ?c ?v)
                          (craves ?v ?n)
                          (harmony ?v ?s1)
                          (orbits ?s1 ?s2))
       :effect (and (not (fears ?c ?v))
                    (craves ?c ?n)
                    (not (harmony ?v ?s1))
                    (harmony ?v ?s2)))
   (:action drink
      :parameters (?n1 ?n2 - food)
      :vars (?l11 ?l12 ?l13 ?l21 ?l22 - province)
      :precondition (and (locale ?n1 ?l11)
                         (attacks ?l12 ?l11)
                         (attacks ?l13 ?l12)
                         (locale ?n2 ?l21)
                         (attacks ?l21 ?l22))
      :effect (and (not (locale ?n1 ?l11))
                   (locale ?n1 ?l12)
                   (not (locale ?n2 ?l21))
                   (locale ?n2 ?l22))))

(define (problem mprime-x-1)
   (:domain mystery-prime-typed)
   (:objects rice pear flounder okra pork lamb - food
             rest - pleasure
             hangover depression abrasion - pain
             kentucky bosnia surrey pennsylvania alsace quebec guanabara
             - province
             mars earth uranus venus - planet)
   (:init (eats lamb pork)
          (eats pork okra)
          (locale okra guanabara)
          (locale pork quebec)
          (eats pork lamb)
          (harmony rest venus)
          (eats lamb flounder)
          (craves depression flounder)
          (eats okra pear)
          (eats rice rice)
          (eats rice flounder)
          (attacks kentucky bosnia)
          (attacks pennsylvania alsace)
          (attacks alsace quebec)
          (craves abrasion pork)
          (locale rice bosnia)
          (orbits mars earth)
          (eats flounder lamb)
          (craves rest pork)
          (orbits earth uranus)
          (locale pear surrey)
          (craves hangover rice)
          (attacks bosnia surrey)
          (attacks surrey pennsylvania)
          (locale lamb pennsylvania)
          (eats flounder rice)
          (eats rice pear)
          (attacks quebec guanabara)
          (eats pear okra)
          (eats pear rice)
          (eats okra pork)
          (orbits uranus venus)
          (locale flounder alsace))
   (:goal (and (craves abrasion rice))))